/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
 * Description:MViz Image数据类型示例代码
 * Create: 2021-08-12
 */
#ifndef MODULES_VIZ_SAMPLE_SRC_SENSOR_VIZ_IMAGE_H_
#define MODULES_VIZ_SAMPLE_SRC_SENSOR_VIZ_IMAGE_H_

#include <publisher.h>
#include "hu_camera.h"
#include "server_activity.h"
#include "camera_drv/executable.h"

#ifndef CONF_SOC_A
#define CONF_SOC_A
#endif
// #undef  CONF_SOC_A

class Image : public ServerActivity{
public:
    Image();
    ~Image() = default;
    void setInputParams(int liveCamId, std::string publishTopic, hi_venc_chn EncChannelNumber, std::string sampleName_,bool aclInit = false);
    void setHucamInstance(HuCam *cameraInstance);
    std::string getSampleName();
    HuCam* getHucamObjectPtr();
    void Init();
    bool OnInit();
    void OnSend();
    void Stop();
    void RunThread();

protected:
    std::shared_ptr<huawei::ap::sample::skeleton::VisualizationSkeleton> skeleton_;
    void CamByIndex(int camera_id);
    void FlushTest(int camera_id);

    void setupPublishers();
    void showBanner();
    void Publish(uint8_t camera_id, mdc::visual::Image image);
    int8_t bufferSize = 5;
    const int width = 1920;
    const int height = 1080;

    mdc::visual::Image getCameraImage(uint8_t *buffer, size_t length, uint32_t camera_id);
    bool inputParamsValid();
    int live_cam_id = -1;
    std::string pub_topic;
    hi_venc_chn channel_number = 255;
    bool acl_init = false;

    bool first_is_init = false;

    bool thread_inited[4] = {false, false, false, false};
    const bool availableCameras[4] = {true, true, true, true};
    
private:

    #ifdef CONF_SOC_A
    uint8_t cam_idx_div_factor = 8;
    #else
    uint8_t cam_idx_div_factor = 4;
    #endif


    std::string topic_prefix = "Camera_";
    int bannerWaitStep = 50;
    const int camSleepValueDefault = 33;

    mdc::visual::Publisher imagePub[4] = {};


    mdc::visual::Image images[4] = {};

    std::thread cameraThread[4] {};
    std::thread mainThread {};
    void MainWorkingThread();
    void CameraWorkingThread(int camera_id);

    HuCam* cameraSample = nullptr;
    HuCam* cameraSample2 = nullptr;
    volatile bool isStop { false };
    //ServerActivity *image_to_send = new Image();
//    huawei::ap::sample::skeleton::events::CameraImageAsyncEvent cameraImageSenders[4];

};

#endif /* MODULES_VIZ_SAMPLE_SRC_SENSOR_VIZ_IMAGE_H_ */
